package main

import "fmt"

type Node struct {
	value       int
	left, right *Node
}

func (n *Node) Traverse(f func(int)) {
	if n == nil {
		return
	}
	n.left.Traverse(f)
	f(n.value)
	n.right.Traverse(f)
}

func main() {
	root := &Node{
		value: 3,
		left: &Node{
			value: 2,
			left:  &Node{value: 1}},
		right: &Node{
			value: 5,
			left:  &Node{value: 4},
			right: &Node{value: 6}}}
	var values []int
	root.Traverse(func(v int) { values = append(values, v) })
	fmt.Println(values)
}
