package main

import "fmt"

func existsInSlice[T comparable](val T, values []T) bool {
	for _, v := range values {
		if val == v {
			return true
		}
	}
	return false
}

func showIn[T comparable](val T, values []T) {
	fmt.Printf("%v in %v => %v\n", val, values, existsInSlice(val, values))
}

func main() {
	showIn("worlds", []string{"Hello", "world"})
	showIn(7, []int8{9, 8, 7, 6, 5, 4})
	showIn(8.3, []float32{9.0, 8.1, 7.2, 6.3, 5.4, 4.5})
	showIn(7+2i, []complex128{9 + 0i, 8 + 1i, 7 + 2i, 6 + 3i})
}
