package main

import (
    "github.com/eiannone/keyboard"
    "fmt"
    "time"
    "context"
)

func main() {
    t0 := time.Now()
    activity()
    fmt.Printf("время выполнения: %v\n", time.Now().Sub(t0))
}

func activity() {
    const d = 4                      // время автономного выполнения - сек.
    var (
        chChan  = make(chan bool, 1) // индикатор ввода клавиатуры
        timer = time.NewTimer(d * time.Second)
    )
    
    ctx, cancel := context.WithCancel(context.Background())
    
    defer func() {
         cancel()
         fmt.Printf("код завершения ветвей = %s\n", ctx.Err())
         timer.Stop()
         keyboard.Close()  
    }()
    
    const потоки = 4                 // запуск горутин "работы"
    for i := 0; i < потоки; i++ {
        go action(ctx)
    }
   
    go func(chChan chan <- bool) {   // горутина ожидание нажатия клавиши
        _, _, _ = keyboard.GetSingleKey()
        chChan <- true 
    }(chChan)

    for {
        select {
        case <-timer.C:              // истечение таймера
            println("timer")
            return
        case <-chChan:               // нажатие клавиатуры
            println("keyboard")
            return
        default:
            time.Sleep(1 * time.Second) 
            println("wait ...")            
        }
    }
}

func action(ctx context.Context) {
    for {
	select {
	case <-ctx.Done():
	    return
	default:                     // выполняемая горутиной "работа"
            time.Sleep(100 * time.Millisecond)
	}
    }
}
