package main

import "net"
import "fmt"
import "bufio"
import "os"
import "io"
import "strconv"

func main() {
	port := "51500"
	if len(os.Args) > 1 {
		_, err := strconv.Atoi(os.Args[1])
		if err != nil {
			fmt.Print("wrong port")
			return
		} else {
			port = os.Args[1]
		}
	}
	fmt.Println("connect to port " + port)
	conn, err := net.Dial("tcp", "127.0.0.1:"+port) // Подключаемся к сокету
	if err != nil {
		fmt.Println("no server available")
		return
	}
	for {
		reader := bufio.NewReader(os.Stdin) // Чтение данных из stdin
		fmt.Print("> ")
		text, err := reader.ReadString('\n')
		if err != nil {
			if err != io.EOF {
				fmt.Print(err)
			}
			fmt.Println()
			return
		}
		if len(text) == 1 {
			break
		}
		fmt.Fprintf(conn, text+"\n")                         // Отправляем в socket
		message, _ := bufio.NewReader(conn).ReadString('\n') // Чтение ответа
		fmt.Print("  " + message)
	}
}
