package main

import (
	"bufio"
	"fmt"
	"github.com/gSpera/meval"
	"io"
	"os"
	"strings"
)

func main() {
	e := meval.New()
	e.SetFn("sum", sum)
	e.SetFn("prod", prod)
	r := bufio.NewReader(os.Stdin)
	for {
		print("? ")
		str, err := r.ReadString('\n')
		if err == io.EOF {
			println()            // ввод ^D - EOF
			break
		}
		if err != nil {
			fmt.Printf("%v\n", err)
			panic(err)
		}
		str = strings.TrimRight(str, " \n")
		if 0 == len(str) {       // ввод Enter - пустая строка
			break
		}
		print(str, " = ")
		value, err := e.Eval(str)
		if err == nil {
			fmt.Printf("%v\n", value)
		} else {
			fmt.Printf("ошибочное выражение: %v\n", err)
		}
	}
}

var sum = func(args ...float64) (float64, error) {
	var sum float64
	for _, arg := range args {
		sum += arg
	}
	return sum, nil
}

var prod = func(args ...float64) (float64, error) {
	var prod float64 = 1.0
	for _, arg := range args {
		prod *= arg
	}
	return prod, nil
}
